%DDEPOKE Send data to application.
%	DDEPOKE sends data to an application via an established DDE
%	conversation. Three transfer formats are supported:
%
%     * two binary Fast File Formats (Excel or Matlab)
%     * ASCII format (numeric matrices are transmitted as strings, default)
%
%	rc = DDEPOKE(channel,item,data,format,timeout)
%
%	rc      Return code: (logical) 0 indicates failure, 1 indicates success.
%	channel Conversation channel from DDEINIT.
%	item    String specifying the DDE item for the data sent. 
%	        Item is the server data entity that is to contain the data 
%	        sent in the data argument.
%	data    Matrix containing the data to send.
%	format  (optional) If NUMERIC, scalar specifying the format of the data 
%	        requested. The value indicates the Windows clipboard format to
%	        use for the data transfer. Use "1" for CF_Text transfer,
%		"13" for CF_UnicodeText, or the value obtained from CLIPFORM
%		to select one of the binary transfers.
%               If no format given, the default format is CF_Text.
%		New: If STRING, this is the clipboard format name directly.
%		Supported formats are 'Text', 'UnicodeText',
%		'XlTable', and 'MatTable'.
%	timeout (optional) Scalar specifying the time-out limit for this
%	        operation.  Timeout is specified in milliseconds.
%	        (1000 milliseconds = 1 second). The default timeout is three
%	        seconds.
%
%	For example,
%	Send a 5x5 identity matrix to Excel
%	rc = ddepoke(channel, 'r1c1:r5c5', eye(5));
%
%       See also DDEINIT, DDETERM, DDEEXEC, DDEREQ, DDEADV, DDEUNADV, CLIPFORM.

%       Copyright (c) 2001 TU Chemnitz
