%DDEUNADV Release advisory link.
%	DDEUNADV releases the advisory link between MATLAB and the server 
%	application, established by an earlier DDEADV call. The channel, 
%	item, and format must be the same as those specified in the call 
%	to DDEADV that initiated the link. If you include the timeout 
%	argument but accept the default format, you must specify format 
%	as an empty matrix.
%
%	rc = DDEUNADV(channel,item,format,timeout)
%
%	rc	Return code: (logical) 0 indicates failure, 1 indicates success.
%	channel	Conversation channel from DDEINIT.
%	item	String specifying the DDE item name associated with 
%		the advisory link. For multiple items, see DDEADV.
%	format  (optional) If NUMERIC, a two-element array specifying the
%		format of the data requested. The first element indicates a
%		Windows clipboard format to use for the request. The value 1
%		corresponds to CF_Text, 13 for CF_UnicodeText;
%		other values can be obtained by	calling CLIPFORM.
%		The second element of the format array
%		specifies the type of the resultant matrix. The valid
%		types are NUMERIC (the default, corresponding to a value
%		of 0) and STRING (corresponding to a value of 1).
%		If no format given, the default format array is [1 0].
%		New: If STRING, this is the clipboard format name directly.
%		Supported formats are 'Text', 'UnicodeText',
%		'XlTable', and 'MatTable'.
%		The left-hand-side will be STRING if 'Text' and 'UnicodeText',
%		NUMERIC otherwise.
%	timeout	(optional) Scalar specifying the time-out limit for this
%		operation.  Timeout is specified in milliseconds.
%		(1000 milliseconds = 1 second). 
%		The default value of timeout is three seconds.
%
%	For example,
%	Release the hot link established in the ddeadv example
%	rc = ddeunadv(channel, 'r1c1:r5c5');
%	
%	Release a hot link with default format and value for timeout
%	rc = ddeunadv(chan, 'r1c1:r5c5',[],6000);
%
%	See also DDEINIT, DDETERM, DDEEXEC, DDEREQ, DDEPOKE, DDEADV, CLIPFORM.

%       Copyright (c) 2001 TU Chemnitz
